diff --git a/doc/guides/conf.py b/doc/guides/conf.py
index 67d2dd62c7..0494b0efe7 100644
--- a/doc/guides/conf.py
+++ b/doc/guides/conf.py
@@ -368,6 +368,11 @@ def setup(app):
                             'Asymmetric',
                             'Asymmetric algorithms in crypto drivers',
                             'Asymmetric algorithm')
+    table_file = dirname(__file__) + '/cryptodevs/overview_os_table.txt'
+    generate_overview_table(table_file, 6,
+                            'OS',
+                            'Operating systems support for crypto drivers',
+                            'Operating system')
     table_file = dirname(__file__) + '/compressdevs/overview_feature_table.txt'
     generate_overview_table(table_file, 1,
                             'Features',
diff --git a/doc/guides/cryptodevs/features/aesni_gcm.ini b/doc/guides/cryptodevs/features/aesni_gcm.ini
index c592298668..58ab133e5f 100644
--- a/doc/guides/cryptodevs/features/aesni_gcm.ini
+++ b/doc/guides/cryptodevs/features/aesni_gcm.ini
@@ -39,3 +39,10 @@ AES GCM (256) = Y
 ; Supported Asymmetric algorithms of the 'aesni_gcm' crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'aesni_gcm' crypto driver.
+;
+[OS]
+Linux = Y
+FreeBSD = Y
diff --git a/doc/guides/cryptodevs/features/aesni_mb.ini b/doc/guides/cryptodevs/features/aesni_mb.ini
index 1883217868..e616f13d50 100644
--- a/doc/guides/cryptodevs/features/aesni_mb.ini
+++ b/doc/guides/cryptodevs/features/aesni_mb.ini
@@ -74,3 +74,10 @@ CHACHA20-POLY1305 = Y
 ; Supported Asymmetric algorithms of the 'aesni_mb' crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'aesni_mb' crypto driver.
+;
+[OS]
+Linux = Y
+FreeBSD = Y
\ No newline at end of file
diff --git a/doc/guides/cryptodevs/features/armv8.ini b/doc/guides/cryptodevs/features/armv8.ini
index beb40c0578..33c1291ce6 100644
--- a/doc/guides/cryptodevs/features/armv8.ini
+++ b/doc/guides/cryptodevs/features/armv8.ini
@@ -32,3 +32,10 @@ SHA256 HMAC  = Y
 ; Supported Asymmetric algorithms of the 'armv8' crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'armv8' crypto driver.
+;
+[OS]
+Linux = Y
+FreeBSD = Y
\ No newline at end of file
diff --git a/doc/guides/cryptodevs/features/bcmfs.ini b/doc/guides/cryptodevs/features/bcmfs.ini
index f7fb2ed884..5def12f8a5 100644
--- a/doc/guides/cryptodevs/features/bcmfs.ini
+++ b/doc/guides/cryptodevs/features/bcmfs.ini
@@ -58,3 +58,10 @@ AES CCM (256)     = Y
 ; Supported Asymmetric algorithms of the 'bcmfs' crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'bcmfs' crypto driver.
+;
+[OS]
+Linux = Y
+FreeBSD = Y
\ No newline at end of file
diff --git a/doc/guides/cryptodevs/features/caam_jr.ini b/doc/guides/cryptodevs/features/caam_jr.ini
index 8d55cdb6cd..ba6d10c880 100644
--- a/doc/guides/cryptodevs/features/caam_jr.ini
+++ b/doc/guides/cryptodevs/features/caam_jr.ini
@@ -49,3 +49,9 @@ AES GCM (256) = Y
 ; Supported Asymmetric algorithms of the 'dpaa2_sec' crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'dpaa2_sec' crypto driver.
+;
+[OS]
+Linux = Y
\ No newline at end of file
diff --git a/doc/guides/cryptodevs/features/ccp.ini b/doc/guides/cryptodevs/features/ccp.ini
index 866d4c52e7..53abd2b68e 100644
--- a/doc/guides/cryptodevs/features/ccp.ini
+++ b/doc/guides/cryptodevs/features/ccp.ini
@@ -63,3 +63,9 @@ AES GCM (256) = Y
 ; Supported Asymmetric algorithms of the 'ccp' crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'ccp' crypto driver.
+;
+[OS]
+Linux = Y
\ No newline at end of file
diff --git a/doc/guides/cryptodevs/features/chacha20_poly1305.ini b/doc/guides/cryptodevs/features/chacha20_poly1305.ini
index 3353e031c9..b5a7b39bd0 100644
--- a/doc/guides/cryptodevs/features/chacha20_poly1305.ini
+++ b/doc/guides/cryptodevs/features/chacha20_poly1305.ini
@@ -33,3 +33,10 @@ CHACHA20-POLY1305 = Y
 ; Supported Asymmetric algorithms of the 'chacha20_poly1305' crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'chacha20_poly1305' crypto driver.
+;
+[OS]
+Linux = Y
+FreeBSD = Y
diff --git a/doc/guides/cryptodevs/features/cn10k.ini b/doc/guides/cryptodevs/features/cn10k.ini
index 9d08bd5c04..ab21d9da43 100644
--- a/doc/guides/cryptodevs/features/cn10k.ini
+++ b/doc/guides/cryptodevs/features/cn10k.ini
@@ -79,3 +79,9 @@ Modular Inversion       =
 Diffie-hellman          =
 ECDSA                   = Y
 ECPM                    = Y
+
+;
+; Supported Operating systems of the 'cn10k' crypto driver.
+;
+[OS]
+Linux = Y
\ No newline at end of file
diff --git a/doc/guides/cryptodevs/features/cn9k.ini b/doc/guides/cryptodevs/features/cn9k.ini
index dd935d439d..d834659d29 100644
--- a/doc/guides/cryptodevs/features/cn9k.ini
+++ b/doc/guides/cryptodevs/features/cn9k.ini
@@ -78,3 +78,9 @@ Modular Inversion       =
 Diffie-hellman          =
 ECDSA                   = Y
 ECPM                    = Y
+
+;
+; Supported Operating systems of the 'cn9k' crypto driver.
+;
+[OS]
+Linux = Y
\ No newline at end of file
diff --git a/doc/guides/cryptodevs/features/default.ini b/doc/guides/cryptodevs/features/default.ini
index 96d95ddc81..018fe0221e 100644
--- a/doc/guides/cryptodevs/features/default.ini
+++ b/doc/guides/cryptodevs/features/default.ini
@@ -118,3 +118,11 @@ Modular Inversion       =
 Diffie-hellman          =
 ECDSA                   =
 ECPM                    =
+
+;
+; Supported Operating systems of a default crypto driver.
+;
+[OS]
+Linux   =
+FreeBSD =
+Windows =
diff --git a/doc/guides/cryptodevs/features/dpaa2_sec.ini b/doc/guides/cryptodevs/features/dpaa2_sec.ini
index a1c91821de..3d6e449ca1 100644
--- a/doc/guides/cryptodevs/features/dpaa2_sec.ini
+++ b/doc/guides/cryptodevs/features/dpaa2_sec.ini
@@ -62,3 +62,9 @@ AES GCM (256) = Y
 ; Supported Asymmetric algorithms of the 'dpaa2_sec' crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'dpaa2_sec' crypto driver.
+;
+[OS]
+Linux = Y
diff --git a/doc/guides/cryptodevs/features/dpaa_sec.ini b/doc/guides/cryptodevs/features/dpaa_sec.ini
index 6a8f77fb1d..77101fa12d 100644
--- a/doc/guides/cryptodevs/features/dpaa_sec.ini
+++ b/doc/guides/cryptodevs/features/dpaa_sec.ini
@@ -62,3 +62,9 @@ AES GCM (256) = Y
 ; Supported Asymmetric algorithms of the 'dpaa_sec' crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'dpaa_sec' crypto driver.
+;
+[OS]
+Linux = Y
diff --git a/doc/guides/cryptodevs/features/kasumi.ini b/doc/guides/cryptodevs/features/kasumi.ini
index fbdb47e89f..d400a4269d 100644
--- a/doc/guides/cryptodevs/features/kasumi.ini
+++ b/doc/guides/cryptodevs/features/kasumi.ini
@@ -30,3 +30,10 @@ KASUMI F9 = Y
 ; Supported Asymmetric algorithms of the 'kasumi' crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'kasumi' crypto driver.
+;
+[OS]
+Linux = Y
+FreeBSD = Y
diff --git a/doc/guides/cryptodevs/features/mlx5.ini b/doc/guides/cryptodevs/features/mlx5.ini
index a89526add0..0d210b2114 100644
--- a/doc/guides/cryptodevs/features/mlx5.ini
+++ b/doc/guides/cryptodevs/features/mlx5.ini
@@ -35,3 +35,10 @@ AES XTS (256)  = Y
 ; Supported Asymmetric algorithms of a mlx5 crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'mlx5' crypto driver.
+;
+[OS]
+Linux = Y
+Windows = Y
diff --git a/doc/guides/cryptodevs/features/mvsam.ini b/doc/guides/cryptodevs/features/mvsam.ini
index 7516c31861..e1d182dd8e 100644
--- a/doc/guides/cryptodevs/features/mvsam.ini
+++ b/doc/guides/cryptodevs/features/mvsam.ini
@@ -58,3 +58,10 @@ AES GCM (256) = Y
 ; Supported Asymmetric algorithms of the 'mvsam' crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'mvsam' crypto driver.
+;
+[OS]
+Linux = Y
+FreeBSD = Y
diff --git a/doc/guides/cryptodevs/features/nitrox.ini b/doc/guides/cryptodevs/features/nitrox.ini
index a1d6bcb4f1..6cab93a343 100644
--- a/doc/guides/cryptodevs/features/nitrox.ini
+++ b/doc/guides/cryptodevs/features/nitrox.ini
@@ -42,3 +42,9 @@ AES GCM (256)  = Y
 ; Supported Asymmetric algorithms of the 'nitrox' crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'nitrox' crypto driver.
+;
+[OS]
+Linux = Y
diff --git a/doc/guides/cryptodevs/features/null.ini b/doc/guides/cryptodevs/features/null.ini
index a1c3e22a36..ae09cdd1c0 100644
--- a/doc/guides/cryptodevs/features/null.ini
+++ b/doc/guides/cryptodevs/features/null.ini
@@ -28,4 +28,11 @@ NULL = Y
 ;
 ; Supported Asymmetric algorithms of the 'null' crypto driver.
 ;
-[Asymmetric]
\ No newline at end of file
+[Asymmetric]
+
+;
+; Supported Operating systems of the 'null' crypto driver.
+;
+[OS]
+Linux = Y
+FreeBSD = Y
\ No newline at end of file
diff --git a/doc/guides/cryptodevs/features/octeontx.ini b/doc/guides/cryptodevs/features/octeontx.ini
index d9776a5788..acc361f99b 100644
--- a/doc/guides/cryptodevs/features/octeontx.ini
+++ b/doc/guides/cryptodevs/features/octeontx.ini
@@ -77,3 +77,10 @@ Modular Inversion       =
 Diffie-hellman          =
 ECDSA                   = Y
 ECPM                    = Y
+
+;
+; Supported Operating systems of the 'octeontx' crypto driver.
+;
+[OS]
+Linux = Y
+FreeBSD = Y
diff --git a/doc/guides/cryptodevs/features/octeontx2.ini b/doc/guides/cryptodevs/features/octeontx2.ini
index 66c5fefde6..c54dc9409c 100644
--- a/doc/guides/cryptodevs/features/octeontx2.ini
+++ b/doc/guides/cryptodevs/features/octeontx2.ini
@@ -79,3 +79,9 @@ Modular Inversion       =
 Diffie-hellman          =
 ECDSA                   = Y
 ECPM                    = Y
+
+;
+; Supported Operating systems of the 'octeontx2' crypto driver.
+;
+[OS]
+Linux = Y
diff --git a/doc/guides/cryptodevs/features/openssl.ini b/doc/guides/cryptodevs/features/openssl.ini
index 74bb987ecd..4b0f9b162e 100644
--- a/doc/guides/cryptodevs/features/openssl.ini
+++ b/doc/guides/cryptodevs/features/openssl.ini
@@ -65,3 +65,10 @@ DSA = Y
 Modular Exponentiation = Y
 Modular Inversion = Y
 Diffie-hellman = Y
+
+;
+; Supported Operating systems of the 'openssl' crypto driver.
+;
+[OS]
+Linux = Y
+FreeBSD = Y
diff --git a/doc/guides/cryptodevs/features/qat.ini b/doc/guides/cryptodevs/features/qat.ini
index 6cc09cde70..bc50ecf032 100644
--- a/doc/guides/cryptodevs/features/qat.ini
+++ b/doc/guides/cryptodevs/features/qat.ini
@@ -82,3 +82,10 @@ CHACHA20-POLY1305 = Y
 Modular Exponentiation  = Y
 Modular Inversion		= Y
 RSA						= Y
+
+;
+; Supported Operating systems of the 'qat' crypto driver.
+;
+[OS]
+Linux = Y
+FreeBSD = Y
\ No newline at end of file
diff --git a/doc/guides/cryptodevs/features/snow3g.ini b/doc/guides/cryptodevs/features/snow3g.ini
index 4d4c5b579b..8d6d809268 100644
--- a/doc/guides/cryptodevs/features/snow3g.ini
+++ b/doc/guides/cryptodevs/features/snow3g.ini
@@ -31,3 +31,10 @@ SNOW3G UIA2 = Y
 ; Supported Asymmetric algorithms of the 'snow3g' crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'snow3g' crypto driver.
+;
+[OS]
+Linux = Y
+FreeBSD = Y
diff --git a/doc/guides/cryptodevs/features/virtio.ini b/doc/guides/cryptodevs/features/virtio.ini
index 5dff094821..8f22b6210b 100644
--- a/doc/guides/cryptodevs/features/virtio.ini
+++ b/doc/guides/cryptodevs/features/virtio.ini
@@ -30,3 +30,10 @@ SHA1 HMAC      = Y
 ; Supported Asymmetric algorithms of the 'virtio' crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'virtio' crypto driver.
+;
+[OS]
+Linux = Y
+FreeBSD = Y
diff --git a/doc/guides/cryptodevs/features/zuc.ini b/doc/guides/cryptodevs/features/zuc.ini
index 1c53454a6c..fa120c1d4d 100644
--- a/doc/guides/cryptodevs/features/zuc.ini
+++ b/doc/guides/cryptodevs/features/zuc.ini
@@ -30,3 +30,10 @@ ZUC EIA3 = Y
 ; Supported Asymmetric algorithms of the 'zuc' crypto driver.
 ;
 [Asymmetric]
+
+;
+; Supported Operating systems of the 'zuc' crypto driver.
+;
+[OS]
+Linux = Y
+FreeBSD = Y
diff --git a/doc/guides/cryptodevs/overview.rst b/doc/guides/cryptodevs/overview.rst
index b87c4c6a27..1172297915 100644
--- a/doc/guides/cryptodevs/overview.rst
+++ b/doc/guides/cryptodevs/overview.rst
@@ -80,3 +80,10 @@ Supported Asymmetric Algorithms
 .. _table_crypto_pmd_asym_algos:
 
 .. include:: overview_asym_table.txt
+
+Supported Operating Systems
+-------------------------------
+
+.. _table_crypto_pmd_os:
+
+.. include:: overview_os_table.txt